routes/web.php
<?php

use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\CustomerController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\SliderController;
use App\Http\Controllers\Admin\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});
# admin
Route::controller(DashboardController::class)->group(function() {
    Route::get('/admin/dashboard', 'index')->name('admin.dashboard.index');
});
# admin / categories
Route::resource('/admin/categories', CategoryController::class, ['as' => 'admin']);

# admin / products
Route::resource('/admin/products', ProductController::class, ['as' => 'admin']);

# admin / orders
// Route::resource('/admin/orders', OrderController::class, ['only' => ['index', 'show'], 'as' => 'admin']);
Route::get('/admin/orders', [OrderController::class, 'index'])->name('admin.orders.index');
Route::get('/admin/orders/{invoice}', [OrderController::class, 'show'])->name('admin.orders.show');

# admin / customers
Route::get('/admin/customers', [CustomerController::class, 'index'])->name('admin.customers.index');

# admin / sliders
Route::resource('/admin/sliders', SliderController::class, ['only' => ['index', 'store', 'destroy'], 'as' => 'admin']);

# admin / profile
Route::get('/admin/profile', [ProfileController::class, 'index'])->name('admin.profile.index');

# admin / users
Route::resource('/admin/users', UserController::class, ['as' => 'admin']);

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    use HasFactory;

    # fillable
    protected $fillable = [
        'image', 'title', 'slug', 'category_id', 'content', 'weight', 'height', 'price', 'discount',
    ];

    # with
    protected $with = [
        'category'
    ];
    # relation table
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function carts()
    {
        return $this->hasMany(Cart::class);
    }

    # route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }

    # attribute
    protected function image(): Attribute
    {
        return Attribute::make(
            get: fn ($value) => asset('/storage/products/img/' . $value),
        );
    }
}

app/Http/Controllers/Admin/ProductController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\Rule;

class ProductController extends Controller
{
    public function __construct()
    {
        $this->middleware(['auth', 'preventBackHistory']);
    }

    # get all data products
    public function index()
    {
        # action get all data products
        $products = Product::latest()->when(request()->q, function ($products) {
            $products = $products->where('title', 'like', '%' . request()->q . '%');
        })->paginate(15);

        # return view
        return view('admin.products.index', compact('products'));
    }

    # view create product
    public function create()
    {
        # get data categories
        $categories = Category::select('id', 'name')->get();
        $product = new Product();

        # return view
        return view('admin.products.create', compact('categories', 'product'));
    }

    # process create product
    public function store(Request $request)
    {
        # validation
        $request->validate([
            'image' => ['required', 'image', 'mimes:jpg,jpeg,png', 'max:2048'],
            'title' => ['required', 'min: 3', 'max: 255', Rule::unique('products', 'title')],
            'category' => ['required'],
            'content' => ['required', 'min: 3'],
            'weight' => ['required', 'integer'],
            'price' => ['required', 'integer'],
            'discount' => ['required', 'integer'],
        ]);

        # upload image handle
        $image = $request->file('image');
        $image->storeAs('products/img', $image->hashName());

        # action create product
        Product::create([
            'image' => $image->hashName(),
            'title' => $request->title,
            'slug' => str($request->title)->slug(),
            'category_id' => $request->category,
            'content' => $request->content,
            'unit' => $request->unit,
            'weight' => $request->weight,
            'price' => $request->price,
            'discount' => $request->discount,
            'keywords' => $request->keywords,
            'description' => $request->description,
        ]);

        # redirect
        return to_route('admin.products.index')->with('success', 'Data product has been created');
    }

    public function show(Product $product)
    {
        //
    }

    # view edit product
    public function edit(Product $product)
    {
        # get data category
        $categories = Category::select('id', 'name')->get();

        # return view
        return view('admin.products.edit', compact('categories', 'product'));
    }

    # process update product
    public function update(Request $request, Product $product)
    {
        # validation
        $request->validate([
            'image' => ['nullable', 'image', 'mimes:jpg,jpeg,png', 'max:2048'],
            'title' => ['required', 'min:3', 'max:255', Rule::unique('products', 'title')->ignore($product)],
            'category' => ['required'],
            'content' => ['required', 'min: 3'],
            'weight' => ['required', 'integer'],
            'price' => ['required', 'integer'],
            'discount' => ['required', 'integer'],
        ]);

        # update image handle
        if ($request->hasFile('image')) {
            if ($product->image) {
                Storage::delete($product->image);
            }
            $image = $request->file('image')->store('products/img');
        } else {
            $image = $product->image;
        }

        # action update product
        if ($request->file('image') == '') {
            $product->update([
                'title' => $request->title,
                'slug' => str($request->title)->slug(),
                'category_id' => $request->category,
                'content' => $request->content,
                'unit' => $request->unit,
                'weight' => $request->weight,
                'price' => $request->price,
                'discount' => $request->discount,
                'keywords' => $request->keywords,
                'description' => $request->description,
            ]);
        } else {
            $image = $request->file('image');
            Storage::disk('public')->delete('products/img/' . basename($product->image));
            $image->storeAs('products/img', $image->hashName());

            $product->update([
                'image' => $image->hashName(),
                'title' => $request->title,
                'slug' => str($request->title)->slug(),
                'category_id' => $request->category,
                'content' => $request->content,
                'unit' => $request->unit,
                'weight' => $request->weight,
                'price' => $request->price,
                'discount' => $request->discount,
                'keywords' => $request->keywords,
                'description' => $request->description,
            ]);
        }

        # redirect
        return to_route('admin.products.index')->with('success', 'Data product has been updated');
    }

    public function destroy(Product $product)
    {
        # delete product image
        Storage::disk('public')->delete('products/img/' . basename($product->image));
        # action delete product
        $product = $product->delete();

        if ($product) {
            return response()->json([
                'status' => 'success'
            ]);
        }
    }
}

app/Http/Controllers/Api/ProductController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    # get all data products
    public function index(Request $request)
    {
        # action get all data products
        $products = Product::latest()->get();

        # return response
        return response()->json([
            'success' => true,
            'message' => 'List Data Products',
            'products' => $products,
        ], 200);
    }

    # get product details
    public function show(Product $product)
    {
        if ($product) {
            # if product success to show
            return response()->json([
                'success' => true,
                'message' => 'Detail Data Product' . $product->name,
                'product' => $product,
            ], 200);
        } else {
            # if product failed to show
            return response()->json([
                'success' => false,
                'message' => 'Data Product Not Found',
            ], 404);
        }
    }
}

resources/views/admin/products/create.blade.php
@extends('layouts.app', ['title' => 'Add Product - GreenK Online Shop'])
@section('content')
<div class="container-fluid mb-5">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-shopping-bag mr-2"></i> Add Product</h6>
        </div>

        {{-- card body --}}
        <div class="card-body">
          <form action="{{ route('admin.products.store') }}" method="POST" enctype="multipart/form-data">
            @include('admin.products.form', ['submit' => 'Save'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/products/edit.blade.php
@extends('layouts.app', ['title' => 'Edit Product - GreenK Online Shop'])
@section('content')
<div class="container-fluid mb-5">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-shopping-bag mr-2"></i> Edit Product</h6>
        </div>

        {{-- card body --}}
        <div class="card-body">
          <form action="{{ route('admin.products.update', $product) }}" method="POST" enctype="multipart/form-data">
            @method('PUT')
            @include('admin.products.form', ['submit' => 'Update'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/products/form.blade.php
@csrf
{{-- image --}}
<div class="form-group">
  <label for="image" class="form-label">Image</label>
  <input type="file" name="image" class="form-control @error('image') is-invalid @enderror" id="image" accept="image/*">
  @error('image')
  <div class="invalid-feedback">
    <strong>{{ $message }}</strong>
  </div>
  @enderror
</div>

{{-- product name --}}
<div class="form-group">
  <label for="title">Product Name</label>
  <input type="text" name="title" class="form-control @error('title') is-invalid @enderror" id="title" value="{{ old('title', $product->title) }}" placeholder="Product Name">
  @error('title')
  <div class="invalid-feedback">
    <strong> {{ $message }}</strong>
  </div>
  @enderror
</div>

<div class="row">
  {{-- category --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="category" class="form-label">Category</label>
      <select name="category" class="form-control @error('category') is-invalid @enderror" id="category">
        <option disabled>Choose Category</option>
        @foreach ($categories as $category)
        <option {{ old('category') == $category->id || $product?->category_id == $category->id ? 'selected' : '' }} value="{{ $category->id }}">
          {{ $category->name }}
        </option>
        @endforeach
      </select>

      @error('category')
      <div class="invalid-feedback">
        <strong>{{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>

  {{-- weight --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="weight" class="form-label">Weight (gram)</label>
      <input type="number" name="weight" class="form-control @error('weight') is-invalid @enderror" id="weight" value="{{ old('weight', $product->weight) }}" placeholder="Product Weight (gram)">
      @error('weight')
      <div class="invalid-feedback">
        <strong>{{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>
</div>

{{-- description --}}
<div class="form-group">
  <label for="content" class="form-label">Description</label>
  <textarea name="content" class="form-control content @error('content') is-invalid @enderror" id="content" rows="10" placeholder="Product Description">{{ old('content', $product->content) }}</textarea>
  @error('content')
  <div class="invalid-feedback">
    <strong>{{ $message }}</strong>
  </div>
  @enderror
</div>

<div class="row">
  {{-- price --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="price" class="form-label">Price</label>
      <input type="number" name="price" class="form-control @error('price') is-invalid @enderror" id="price" value="{{ old('price', $product->price) }}"
      placeholder="Product Price (Rp)">
      @error('price')
      <div class="invalid-feedback">
        <strong>{{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>

  {{-- discount --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="discount" class="form-label">Discount (%)</label>
      <input type="number" name="discount" class="form-control @error('discount') is-invalid @enderror" id="discount" value="{{ old('discount', $product->discount) }}"
      placeholder="Discount (%)">
      @error('discount')
      <div class="invalid-feedback">
        <strong>{{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>
</div>

{{-- button submit --}}
<button class="btn btn-primary mr-1 btn-submit" type="submit">
  {{ $submit }}
</button>

<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/5.10.4/tinymce.min.js"></script>
<script>
  var editor_config = {
    selector: "textarea.content"
    , plugins: [
      "advlist autolink lists charmap print preview hr anchor pagebreak"
      , "searchreplace wordcount visualblocks visualchars code fullscreen"
      , "insertdatetime nonbreaking save table contextmenu directionality"
      , "emoticons template paste textcolor colorpicker textpattern"
    ]
    , toolbar: "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image media"
    , relative_urls: false
  , };

  tinymce.init(editor_config);
</script>

resources/views/admin/products/index.blade.php
@extends('layouts.app', ['title' => 'Products - GreenK Online Shop'])

@section('content')
<div class="container-fluid mb-5">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fa fa-shopping-bag mr-2"></i>
            Prodcuts
          </h6>
        </div>

        {{-- card-body --}}
        <div class="card-body">
          <form action="{{ route('admin.products.index') }}" method="GET">
            <div class="row">
              <div class="col-md-4 mb-3 mb-md-0">
                <a href="{{ route('admin.products.create') }}" class="btn btn-primary btn-md">
                  Add Product
                </a>
              </div>

              {{-- search products--}}
              <div class="col-md-8">
                <div class="form-group">
                  <div class="input-group">
                    <input type="search" class="form-control form-control-md" name="q" placeholder="Search Products...">
                    <div class="input-group-append">
                      <button type="submit" class="btn btn-primary"><i class="fa fa-search"></i></button>
                    </div>
                  </div>
                </div>
              </div>

            </div>
          </form>
          {{-- table of products --}}
          <div class="table-responsive">
            <table class="table table-hover">
              <thead>
                <tr>
                  <th scope="col" style="text-align: center;width: 6%">No.</th>
                  <th scope="col">Product Name</th>
                  <th scope="col">Image</th>
                  <th scope="col">Price</th>
                  <th scope="col">Discount</th>
                  <th scope="col">Category</th>
                  <th scope="col" style="width: 15%;text-align: center">Action</th>
                </tr>
              </thead>
              <tbody>
                @forelse ($products as $product)
                <tr>
                  <td scope="row" class="text-center">
                    {{ $products->firstItem() + $loop->index }}
                  </td>
                  <td scope="row">
                    {{ $product->title }}
                  </td>
                  <td scope="row">
                    <img src="{{ asset($product->image) }}" style="width: 70px; height: 60px">
                  </td>
                  <td scope="row" style="width: 155px">
                    {{ moneyFormat($product->price) }}
                  </td>
                  <td scope="row">
                    {{ $product->discount }}%
                  </td>
                  <td scope="row">
                    {{ $product->category?->name }}
                  </td>
                  <td scope="row" class="text-center">
                    <a href="{{ route('admin.products.edit', $product) }}" class="btn btn-primary btn-sm mb-2 mb-md-0">
                      <i class="fa fa-pencil-alt"></i>
                    </a>
                    <button onclick="Delete(this.id)" class="btn btn-sm btn-danger" id="{{ $product->slug }}">
                      <i class="fa fa-trash"></i>
                    </button>
                  </td>
                </tr>
                @empty
                <tr>
                  <td scope="row" colspan="7">
                    <div class="text-danger text-center">No data products.</div>
                  </td>
                </tr>
                @endforelse
              </tbody>
            </table>
            <div style="text-align: center">
              {{ $products->links() }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<script>
    /* ajax delete */
    function Delete(id) {
      var id = id;
      var token = $("meta[name='csrf-token']").attr("content");

      Swal.fire({
        title: "Want to delete this data?"
        , text: "Data that has been deleted cannot be recovered"
        , icon: "warning"
        , showCancelButton: true
        , confirmButtonColor: '#3085d6'
        , cancelButtonColor: '#d33'
        , confirmButtonText: 'Yes, delete it!'
      }).then((result) => {
        if (result.isConfirmed) {
          jQuery.ajax({
            url: "/admin/products/" + id
            , data: {
              "id": id
              , "_token": token
            }
            , type: "DELETE"
          });
          Swal.fire({
            position: 'center'
            , icon: 'success'
            , title: 'Data product has been deleted'
            , showConfirmButton: false
            , timer: 1500
          , }).then(function() {
            location.reload();
          });
        }
      });
    }
</script>
@endsection